import { PolylineEdge, PolylineEdgeModel } from "@logicflow/core";

class FlowLinkModel extends PolylineEdgeModel {
  initEdgeData(data) {    
    super.initEdgeData(data);    
  }
  getEdgeStyle() {
    const style = super.getEdgeStyle();
    style.strokeWidth = 1;
    style.stroke = this.isSelected ? "#ff7f0e" : "#999";
    return style;
  }
  setAttributes() {
    this.isAnimation = true;
  }
  
  getEdgeAnimationStyle() {
    let tmps=this.graphModel.edges.filter(d=>d.targetNodeId==this.sourceNodeId||d.sourceNodeId==this.sourceNodeId);
    const colors=["#d34836","#0f9d58","#ff7f0e","#2ec2b3","#24799e","#7fba00","#4A148C","#1E88E5","#827717","#4E342E","#212121","#76FF03","#004D40","#2962FF","#283593"] ;
    
    const style = super.getEdgeAnimationStyle();
    style.strokeDasharray = "5 5";
    style.stroke=colors[tmps.indexOf(this)%colors.length];
    style.animationDuration = "60s";
    return style;
  }
}
class FlowLink extends PolylineEdge {

}

export default {
  type: "ai-link",
  view: FlowLink,
  model: FlowLinkModel,
};
